#EzProtection by MiB
from __future__ import with_statement
import es
import gamethread
import playerlib
import langlib
import cfglib
from . import ex
from os.path import join
ee = es.import_addon("extendedevents")
try:
    import spe
    es.dbgmsg(0,"-EzProtection-: Source Python Extentions found, using SPE for certain functions.")
    isSPE = True
except ImportError:
    es.dbgmsg(0,"-EzProtection-: Source Python Extentions not found, using ES for certain functions.")
    isSPE = False

_self = __import__(__name__)

_info = es.AddonInfo()
_info["name"] = "EzProtection"
_info["basename"] = "ezprotection"
_info["version"] = "0.4"
_info["authors"] = "MiB"
_info["url"] = "http://www.sddcommunity.com"
_info["description"] = "EzProtection is a great and easily configurable spawn protection."

_gamedir = str(es.ServerVar("eventscripts_gamedir"))
ee.loadEvent("player_health")

with open(join(_gamedir,"cfg/eventscripts/ezprotection/mapfilter.txt"),"rw") as fo:
    _mapfilter = []
    for line in fo.readlines():
        if not bool(line) or line.startswith("//"):
            continue
        _mapfilter.append(line)
with open(join(_gamedir,"cfg/eventscripts/ezprotection/weaponfilter.txt"),"rw") as fo:
    _weaponfilter = []
    for line in fo.readlines():
        if not bool(line) or line.startswith("//"):
            continue
        _weaponfilter.append(line)
_map = es.ServerVar("eventscripts_currentmap")
_lang = langlib.Strings(join(_gamedir + "/cfg/eventscripts/ezprotection/strings.ini"))
_cfg = cfglib.AddonCFG(join(_gamedir,"cfg/eventscripts/ezprotection/config.cfg"))
_cfg.text("This is the config file for EzProtection v" + _info["version"] + ".")
_cfg.text("If information about the mod is needed please goto addons.eventscripts.com/addons/view/" + _info["basename"] + ".")
_cfg.text(" ")
_cfg.text("-General Settings-")
_cfg.text("Heres where the general settings for EzProtection will be.")
_cfg.text(" ")
_roundmsg = _cfg.cvar("ez_pro_roundmsg",1,"Should EzProtection message on round start that spawn protection is active?")
_tell = _cfg.cvar("ez_pro_tell",1,"Should EzProtection display the protection timer to players?")
_time = _cfg.cvar("ez_pro_time",3,"How long should spawn protection last?")
_type = _cfg.cvar("ez_pro_type","spawn","When should spawn protection occur? (spawn/round start)")
_botblock = _cfg.cvar("ez_pro_bot_block",0,"Should EzProtection block bots from recieving protection?")
_cfg.text(" ")
_cfg.text(" ")
_cfg.text("-Protection Settings-")
_cfg.text("Heres where the spawn protection settings for EzProtection will be.")
_cfg.text(" ")
_god = _cfg.cvar("ez_pro_god_mode",0,"Should spawn protection include god mode?")
_noblock = _cfg.cvar("ez_pro_noblock",0,"Should spawn protection include noblock?")
_hurtback = _cfg.cvar("ez_pro_hurt_back",1,"Should spawn protection include hurting back the attacker?")
_giveback = _cfg.cvar("ez_pro_give_back",1,"Should spawn protection include giving back the damage the protected took as health to the protected?")
_sethealth = _cfg.cvar("ez_pro_set_health",0,"Should spawn protection include setting health?")
_sethealth_setting = _cfg.cvar("ez_pro_set_health_setting",5000,"If so what health should the player be set to during protection?")
_sethealth_rsetting = _cfg.cvar("ez_pro_set_health_rsetting","#health","If so what health setting should the player be set back to after spawn protection is over? \n// (use the setting '#health' if you want it to be the player's original health / or use the setting #leave to make it not reset the player's health)")
_cfg.text(" ")
_cfg.text(" ")
_cfg.text("-Color Settings-")
_cfg.text("Heres where the color settings for EzProtection will be.")
_cfg.text(" ")
_color = _cfg.cvar("ez_pro_color",0,"Should spawn protection color the protected?")
_tcolor = _cfg.cvar("ez_pro_tcolor","255,0,0,200","What color should Ts be while protected?")
_trcolor = _cfg.cvar("ez_pro_trcolor","#reset","What color should Ts be after protection? (rgba value/#reset to use color before protection)")
_ccolor = _cfg.cvar("ez_pro_ccolor","0,0,255,200","What color should CTs be while protected?")
_crcolor = _cfg.cvar("ez_pro_crcolor","#reset","What color should CTs be after protection? (rgba value/#reset to use color before protection)")
_cfg.write()

#~Thanks to Absolute~#
class Players(dict):
    def __init__(self,fixed_type=str,*args,**kwargs):
        self._fixed_type = fixed_type
        dict.__init__(self, *args, **kwargs)
       
    def __setitem__(self,key,value):
        dict.__setitem__(self, self._fixed_type(key),value)
       
    def __getitem__(self,key):
        return dict.__getitem__(self,self._fixed_type(key))
       
    def __contains__(self,key):
        return dict.__contains__(self,self._fixed_type(key))
       
    def __delitem__(self,key):
        dict.__delitem__(self,self._fixed_type(key))

players = Players(str)

class spawnpro():
    def __init__(self,userid):
        self.userid = userid
        self.player = playerlib.getPlayer(userid)

    def start(self):
        if not self.userid in players:
            return
        players[self.userid]["count"] += 1
        self.health = self.player.health
        if es.getplayerteam(self.userid) == 3:
            self.color = map(float,str(_ccolor).split(","))
            if _crcolor == "#reset":
                self.ncolor = self.player.getColor()
            else:
                self.ncolor = map(float,str(_crcolor).split(","))
        else:
            self.color = map(float,str(_tcolor).split(","))
            if _trcolor == "#reset":
                self.ncolor = self.player.getColor()
            else:
                self.ncolor = map(float,str(_trcolor).split(","))
        self.timer(int(_time),players[self.userid]["count"])

    def timer(self,time,count):
        if not self.userid in players or not es.exists("userid",self.userid):
            return
        if self.player.isdead or count != players[self.userid]["count"]:
            return
        if _tell:
            lang_tell(self.userid,"protectiontime",{"ptime":time},style="center")
        if time:
            if _god:
                self.player.godmode = 1
            if _noblock:
                self.player.noblock = 1
            if _hurtback:
                players[self.userid]["hurtback"] = 1
            if _giveback:
                players[self.userid]["giveback"] = 1
            if _sethealth:
                self.player.health = _sethealth_setting
            if _color:
                self.player.setColor(self.color[0],self.color[1],self.color[2],self.color[3])
            time -= 1
            gamethread.delayedname(1,"spawnprotection",self.timer,(time,count))
        else:
            if _god:
                self.player.godmode = 0
            if _noblock:
                self.player.noblock = 0
            if _hurtback:
                players[self.userid]["hurtback"] = 0
            if _giveback:
                players[self.userid]["giveback"] = 0
            if _sethealth:
                if _sethealth_rsetting == "#health":
                    self.player.health = self.health
                elif _sethealth_rsetting == "#leave":
                    pass
                else:
                    self.player.health = _sethealth_rsetting
            if _color:
                self.player.setColor(self.ncolor[0],self.ncolor[1],self.ncolor[2],self.ncolor[3])

def bb(userid):
    return bool(es.isbot(userid) and _botblock)

def lang_msg(langval,langtok,style="tell"):
    for userid in players:
        if es.isbot(userid) or not es.exists("userid",userid):
            continue
        language = playerlib.getPlayer(userid).get("lang")
        if style == "tell":
            es.tell(userid,"#multi",_lang("tag",{},"special") + _lang(langval,langtok,language))
        else:
            es.centertell(userid,_lang(langval,langtok,language))

def lang_tell(userid,langval,langtok,style="tell"):
    if es.isbot(userid) or not es.exists("userid",userid):
        return
    language = playerlib.getPlayer(userid).get("lang")
    if style == "tell":
        es.tell(userid,"#multi",_lang("tag",{},"special") + _lang(langval,langtok,language))
    else:
        es.centertell(userid,_lang(langval,langtok,language))

def reset(userid):
    players[userid] = {}
    players[userid]["count"] = 0
    players[userid]["giveback"] = 0
    players[userid]["hurtback"] = 0

def load():
    if isSPE:
        spe.registerPreHook("player_hurt",_player_hurt)
    else:
        es.addons.registerForEvent(_self,"player_hurt",_player_hurt)
    _cfg.execute()
    es.dbgmsg(0,"-EzProtection-: Finished loading.")
    es.ServerVar("ez_pro_version",_info["version"],"What version is EzProtection?").makepublic()
    for userid in es.getUseridList():
        if not es.exists("userid",userid):
            continue
        reset(userid)
    lang_msg("sload",{"version":_info["version"]})

def unload():
    if isSPE:
        spe.unregisterPreHook("player_hurt",_player_hurt)
    else:
        es.addons.unregisterForEvent("player_hurt",_player_hurt)
    es.dbgmsg(0,"-EzProtection-: Finished unloading.")
    lang_msg("sunload",{})

def round_end(ev):
    gamethread.cancelDelayed("spawnprotection")

def round_start(ev):
    if str(_map) in _mapfilter:
        return
    lang_msg("roundmessage",{"setting":_type})
    if _type == "round start":
        for userid in players:
            if playerlib.getPlayer(userid).isdead or bb(ev["userid"]):
                continue
            spawnpro(userid).start()

def _player_hurt(ev):
    if str(_map) in _mapfilter or bb(ev["userid"]):
        return
    if ev["weapon"] in _weaponfilter or not ev["userid"] in players or ev["userid"] == ev["attacker"]:
        return
    if _hurtback:
        damage = players[ev["userid"]]["chealth"] - int(ev["health"])
        if players[ev["userid"]]["hurtback"] == 1 and es.exists("userid",ev["attacker"]):
            if playerlib.getPlayer(ev["attacker"]).health != 0:
                ex.damage(ev["userid"],ev["attacker"],damage)
                lang_tell(ev["attacker"],"hurtback",{"damage":damage})
    if _giveback:
        if players[ev["userid"]]["giveback"] == 1:
            playerlib.getPlayer(ev["userid"]).health += damage
            lang_tell(ev["userid"],"giveback",{"damage":damage})

def player_health(ev):
    health = int(ev["old_health"]) + int(ev["change_health"])
    players[ev["userid"]]["chealth"] = health

def player_spawn(ev):
    if str(_map) in _mapfilter or bb(ev["userid"]) or not es.exists("userid",ev["userid"]):
        return
    if not ev["userid"] in players:
        reset(ev["userid"])
    player = playerlib.getPlayer(ev["userid"])
    if player.isdead:
            return
    players[ev["userid"]]["chealth"] = player.health
    if _type == "spawn":
        spawnpro(ev["userid"]).start()

def player_disconnect(ev):
    if ev["userid"] in players:
        del players[ev["userid"]]
